<!-- Extensions.md - Removable HEADER Start -->

<style>
th {
   white-space: nowrap;
}

table, th, td {
   padding: 6px 13px;
   border: 1px solid #DDD;
   border-collapse: collapse;
   border-spacing: 0px;
}
</style>

Last edited: Apr 12, 2016

<!-- Removable HEADER End -->

## <a name="ext_top"></a> Server Extensions

> [Table of Contents](#doc_top)

> [Description](#ext_des)  
> [Hangup Extension](#ext_hup)

### <a name="ext_des"></a> Description

> The ncidd server supports **Server Extensions**.  A Server Extension is an external script or
  program that is called by ncidd to perform a function and return a result. Server Extensions 
  are a way for users to add functionality to NCID without requiring changes to NCID itself.
  Server Extensions are isolated from the main NCID distribution, and because of this they
  do not normally require any changes when NCID is upgraded to a later version.

> You can use any scripting or programming language desired.  
  
### <a name="ext_hup"></a> Hangup Extension

> The first Server Extension distributed with NCID is the **Hangup Extension**. It can be 
> used with and without using Internal Hangup. (Internal Hangup is defined as call termination
> using the `ncidd.blacklist` and `ncidd.whitelist` files.) If used with the Internal Hangup,
> it will be executed only if the Internal Hangup does not terminate the call. Hangup
> Extensions use all of the same Internal Hangup modes (normal, fax, announce).
> Be sure to review the required [Modem Configuration](#hangup_modem_config) parameters.

> Three settings in ncidd.conf control Hangup Extensions:

>>>
 Setting         | Values 
 --------------  | :-----
set&nbsp;hupmode | <br> 0 = disabled <br> 1 = [Normal Hangup](#hangup_norm)   <br> 2 = [Fax Hangup](#hangup_fax) <br> 3 = [Announce Hangup](#hangup_ann) <br><br> default: 0 <br>&nbsp;
set&nbsp;hupname | <br> the name of the hangup script or program  <br><br> default: hangup-skel <br>&nbsp;
set&nbsp;huprmd  | <br> optional voice file to be played if hupmode = 3 <br><br> default: "announce" file used by Internal Hangup (usually **NumberDisconnected.rmd**) <br>&nbsp;

> You create your own Hangup Extension script/program external to NCID in whatever language 
> you would like. It can have whatever logic you wish for terminating a call. You can even
> have it return the name of a customized voice message file for
> individual phone numbers.

>  The technical details of creating a Hangup Extension are outside the
   scope of this document (see [NCID-API](http://ncid.sourceforge.net/doc/NCID-API.html)).
   However, two example Hangup Extensions are included with NCID:

> - The [hangup-skel](http://ncid.sourceforge.net/man/hangup-skel.1.html) extension is a very basic
    template to determine if the number or name received should tell ncidd to hangup. You might use
    this as a starting point, for example, to query an Internet site to determine if the
    call should be terminated. Or perhaps you have a local relational database with names or
    numbers of blacklisted callers.

> - The [hangup-message](http://ncid.sourceforge.net/man/hangup-message.1.html) script is a
    complete working script that contains a sample list of phone numbers with their
    corresponding name of a recorded voice file that is played before terminating the call.
    Just replace the sample data with your own and you are good to go.  There are no 
    provisions to record a message from the caller; NCID is not an answering machine.

> It is best to rename the sample script used so NCID updates will not write over your script.

> When you enable a Hangup Extension, you also need to indicate the hangup script to use.  The
  default is **hangup-skel** which will run, but it will never trigger a hangup.  When testing
  your script you can give the full path name to where it is located.  When it's working OK,
  copy it to the path appropriate for your operating system:

>> **/usr/share/ncid/extensions** 

>> or 

>>  **/usr/local/share/ncid/extensions**

> Once there you can just give the name of the script in ncidd.conf:

>> **set hupname = hangup-custom**

> When Caller ID is received from a modem and it is not terminated
> by the Internal Hangup logic, the server will check to see if a
> Hangup Extension has been enabled.  If so, the server will pass
> the current call info to the Hangup Extension, execute it, and
> wait for a response. If the Hangup Extension results in a
> positive match by returning the word **hangup**, call
> termination will take place automatically.

  
