<!-- ReleaseNotes.md -->

<style>
th {
   white-space: nowrap;
}

table, th, td {
   padding: 6px 13px;
   border: 1px solid #DDD;
   border-collapse: collapse;
   border-spacing: 0px;
}
</style>

# Release Notes for NCID 1.4

## Index

> * NCID Distributions
> * Distribution Changes
> * Server Changes
> * Gateway Changes
> * Client Changes
> * Client Output Module Changes
> * Tool Changes
> * Documentation Changes

## NCID Distributions

> * SourceForge
> * Fedora packages
> * RPM based OS packages
> * Macintosh OS X package
> * FreeBSD package
> * Ubuntu packages
> * Debian based OS packages

> ### SourceForge
> 
>>Description                   |File name(s)
>>------------------------------|----------
 NCID source package           |ncid-1.4-src.tar.gz
                               |
 Cygwin 32 bit Windows package |ncid-1.4-cygwin_install.sh
                               |
 Debian packages               |Ubuntu packages should install as-is
                               |
 Fedora 64 bit package         |ncid-1.4-1.fc23.x86_64.rpm
                               |
 Fedora no-arch packages       |ncid-client-1.4-1.fc23.noarch.rpm <br>ncid-kpopup-1.4-1.fc23.noarch.rpm <br>ncid-mythtv-1.4-1.fc23.noarch.rpm <br>ncid-samba-1.4-1.fc23.noarch.rpm <br>ncid-speak-1.4-1.fc23.noarch.rpm
                               |
 FreeBSD 32 bit package        |ncid-1.4-FreeBSD-10.2_install.sh
                               |
 Macintosh 64 bit OS X package |ncid-1.4-mac-osx_install.sh <br>(Universal binary, OSX 10.4+)
                               |
 Raspberry Pi packages         |ncid_1.4-1_armhf.deb <br>(other packages are the same as Ubuntu)
                               |
 TiVo Series 2-3 package       |ncid-1.4-mips-tivo_install.sh
                               |
 Ubuntu 64 bit package         |ncid_1.4-1_amd64.deb
                               |
 Ubuntu no-arch packages       |ncid-client_1.4-1_all.deb <br>ncid-kpopup_1.4-1_all.deb <br>ncid-mythtv_1.4-1_all.deb <br>ncid-samba_1.4-1_all.deb <br>ncid-speak_1.4-1_all.deb
                               |
 Windows client installer      |ncid-1.4-client_setup.exe


> ### Fedora packages

>> Available at the Fedora repository.
  New release first appears in the rawhide repository.
  There are server, client, and optional output module packages.
  Normally you only need to install the **ncid** and **ncid-client** rpm packages.

>> The dnf list command will show you the packages available:
>>
          dnf list ncid\*

>> If the above does not show version 1.4:
>>
          dnf --enablerepo=rawhide list ncid\*

>> If the rawhide repo is not installed:
>>
          dnf install fedora-release-rawhide

>> If you need to build packages for your specific OS release:
>>
          rpmbuild -tb ncid-1.4-src.tar.gz

> ### RPM based OS packages

>> Includes Fedora, Redhat, CentOS, etc.

>> If a dependency can not be resolved, you should try rebuilding packages:
>>
          - Download the latest NCID deb packages from sourceforge:
            ncid RPM Package
            ncid-client RPM Package - client and default output modules
          - Download any optional output modules wanted:
            ncid-MODULE RPM Package  - optional client output modules
          - Install or Upgrade the packages using dnf
                * Install the NCID server and gateways:
                  sudo dnf install ncid-<version>.fc23.x86_64.rpm
                * Install the client package and default modules:
                  sudo dnf install ncid-client-<version>.fc23.x86_64.rpm
                * Install any optional modules wanted:
                  sudo gdebi ncid-<module-<version>.fc23.x86_64.rpm
>>
          Notes:
              <version> would be something like: 1.4-1
              <module> would be a module name like: kpopup, mythtv, samba

> ### Macintosh OS X package

>> The version available at MacPorts is 0.83 which was released
>> October 2011. It is not currently maintained:  
>>
>>>  http://trac.macports.org/browser/trunk/dports/net/ncid/Portfile
>>  
>>Use the version available at SourceForge.

> ### FreeBSD package

>> Available at FreshPorts.
>> 
>>>    http://www.freshports.org/comms/ncid/

> ### Ubuntu packages
> and
>
> ### Debian based OS packages

>> Includes Debian, Ubuntu, Raspbian, etc.

>> The official repository for Debian/Ubuntu has not been updated since NCID
>> version 0.88 was released in January 2014.

>> Install from the files at SourceForge:
>>
        - Download the latest NCID DEB packages from SourceForge:
          ncid DEB Package
          ncid-client DEB Package - client and default output modules
>>
        - Download any optional output modules wanted:
          ncid-MODULE DEB Package  - optional client output modules
>>
        - Install or Upgrade the packages using the gdebi-gtk (GUI):
            * If needed use the the menu item "Add/Remove.." to install the
              GDebi Package Installer.
            * Using the file viewer:
                - Open the file viewer to view the NCID DEB packages
                - Select the DEB packages
                - double-click selections or right-click selections and select
                  "Open with GDebi Package installer"
>>
        - Install or Upgrade the packages using gdebi (command line):
            * Install gdebi if needed:
              sudo apt-get install gdebi    
            * Install the NCID server and gateways:
              sudo gdebi ncid-<version>_<processor>.deb
            * Install the client package and default modules:
              sudo gdebi ncid-client-<version>_all.deb
            * Install any optional modules wanted:
              sudo gdebi ncid-<module-<version>_all.deb
>>
        Notes:
            <version> would be something like: 1.4-1
            <processor> would be something like: i386, armhf, amd64
            <module> would be a module name like: kpopup, mythtv, samba

>> If you need to build a package for your specific OS or release, the
  build-essential, fakeroot, and libpcap packages must be installed:
>>
            sudo apt-get build-essential fakeroot libpcap0.8-dev
            tar -xzf ncid-1.4-src.tar.gz
            mv ncid ncid-1.4
            cd ncid-1.4
            fakeroot debian/rules build
            fakeroot debian/rules binary
            fakeroot debian/rules clean

## Distribution Changes

> Cygwin:

> Fedora, Redhat, and RPM based systems:

> - Improved all service scripts and updated yac2ncid.service for yac2ncid.sh changes.

> - Updated yac2ncid.init for yac2ncid.sh changes.

> FreeBSD:

> - Updated yac2ncid.rc for yac2ncid.sh changes.

> Mac OS X:

> Ubuntu, Raspbian, Debian based systems:

> - The package now handles existing config files instead of always overwriting them.

> - The package now correctly recognizes the latest tcl/tk dependencies.

> - Updated yac2ncid.init for yac2ncid.sh changes.

> TiVo:

> Windows:

## Server Changes

> ncidd:

> - added a server extension for external scripts to determine if ncidd
    should hangup on the call
> - allow hangup extension to specify recording file to play before hangup
> - fixed typo so client jobs work using regex
> - revised modem code to be faster in querying modem
> - Fixed modem code so ncidd works with PCI modems. A
    3Com Corp Modem Division 56K FaxModem Model 5610 (rev 01)
    was available for testing.
> - Fixed a client job bug where "UPDATE" was in a name like "POWERUPDATE"

> ncidd.conf:

> - added new variables with comments: hupname, hupmode, and huprmd

> ncidd Extensions:

> - new

## Gateway Changes

> ncid2ncid:

> obi2ncid:

> rn2ncid:

> sip2ncid:

> wc2ncid:

> yac2ncid:

> - Added getopts() to handle options.

> - Added -p, -v and -V options.


## Client Changes

> ncid:

> - "Server Options" added in Help Menu to indicate when these server options are enabled: hangup, hupmode, ignore1, and regex

## Client Output Module Changes

> all modules:

> ncid-page:

## Tool Changes

> cidalias:

> cidcall:

> - fixed problems

> cidupdate:

> - modified code to handle one or more '*'s in message

> ncidutil:

## Documentation Changes

> - fixed man pages to show either /usr/share or /usr/local/share

> - added man pages: hangup-skel.1 hangup-message.1

> - updated man pages ncid-notify.1 and ncid-page.1 to ensure accurate content

> - updated man page ncid-skel.1 with correct skel_types

> - minor typos corrected in man page ncid-wakeup.1

> - updated man page ncidd.8

> - updated man page yac2ncid.1

> - INSTALL.md: 
>  - added new 'End of startup' to log examples in test sections
>  - Debian, Ubuntu and Raspberry Pi now have their own compile/install 'make' targets
>  - formatting and layout changes

> - INSTALL-Mac.md: remove backslash in newsyslog.conf example

> - INSTALL-Raspbian.md: 
>  - added steps to launch ncid GUI after users login
>  - formatting and layout changes

> - INSTALL-Ubuntu.md: 
>  - removed instructions for installing from repository
>  - added section describing possible conflict with ModemManager
>  - formatting and layout changes

> - INSTALL-TiVo.md: 
>  - added new 'End of startup' to log examples in test sections
>  - change 'set modem' to 'set ttyport'
>  - change 'sttyclocal' to 'ttyclocal'
>  - formatting and layout changes

> - Hangup.md: 
>  - extensive rewrite on how to create voice files from scratch based
     on user feedback     

> - Extensions.md: new section describing Server Extensions

> - Modems.md: clarify the 'Modem is fd x' value is a number less than 10

